Option Explicit
Dim objFso

Dim wiaFormatPNG
wiaFormatPNG  = "{B96B3CAF-0728-11D3-9D7B-0000F81EF32E}"

'==============================================================
' 摜TCYύX
'==============================================================
Sub resizeImage(input, outputpath, intWidth)
  Dim objImg
  Dim objIp
  Dim output

  input  = objFso.GetAbsolutePathName(input)
  output = objFso.GetAbsolutePathName(outputpath & "\" & objFso.getBaseName(input) &".png")
  
  if objFso.FileExists(input) And Not objFso.FileExists(output) And Not objFso.FolderExists(output) And isImgFile(input) then

    Set objImg  = CreateObject("WIA.ImageFile")
    objImg.LoadFile(input)

    Set objIp  = CreateObject("WIA.ImageProcess")
    objIp.Filters.Add(objIp.FilterInfos("Scale").FilterID)
    objIp.Filters(1).Properties("MaximumWidth").Value = intWidth
    objIp.Filters(1).Properties("MaximumHeight").Value = objImg.Height * (intWidth/objImg.Width)

    objIp.Filters.Add(objIp.FilterInfos("Convert").FilterID)
    objIp.Filters(2).Properties("FormatID").Value = wiaFormatPNG

    Set objImg = objIp.Apply(objImg)

    objImg.SaveFile(objFso.GetAbsolutePathName(output))

  End if

  Set objImg = Nothing
  Set objIp = Nothing
End Sub

'==============================================================
' t@C^CvmF
'==============================================================
Function isImgFile(input)
  isImgFile=False
  
  If LCase(objFso.GetExtensionName(input)) = "png" Or _ 
     LCase(objFso.GetExtensionName(input)) = "jpg" Or LCase(objFso.GetExtensionName(input)) = "jpeg" Or _ 
     LCase(objFso.GetExtensionName(input)) = "gif" Or _
     LCase(objFso.GetExtensionName(input)) = "bmp" Then
    isImgFile=True
  End if
End Function

'==============================================================
' tH_̏ꍇ̏
'==============================================================
Sub ProcessingFolder(strTargetPath, strWorkDir, intWidth)
  Dim intMsgRet
  Dim objFolder
  Dim objFile
  
  Set objFolder = objFso.GetFolder(strTargetPath)
  
  intMsgRet=MsgBox("hbOtH_ɂ摜t@Cgk܂B" & vbCrLf & _
                   "(TutH_͓WJ܂B)" ,  vbOKCancel,  "mF")
  If intMsgRet = 2 Then  '2:vbCancel
    Wscript.Quit()
  End If
  
  For Each objFile In objFolder.Files
    call resizeImage(strTargetPath & "\" & objFile.Name, strWorkDir, intWidth)
  Next
End Sub

'==============================================================
' t@C̏ꍇ̏
'==============================================================
Sub ProcessingFile(strTargetPath, strWorkDir, intWidth)
  Dim intMsgRet
  Dim strFileName
    
  strFileName = objFso.GetFileName(strTargetPath)

  intMsgRet=MsgBox("hbOt@Cu" & strFileName & "vgk܂B" ,  vbOKCancel,  "mF")
  If intMsgRet = 2 Then  '2:vbCancel
    Wscript.Quit()
  End If
  
  call resizeImage(strTargetPath, strWorkDir, intWidth)
End Sub

'==============================================================
' Jn
'==============================================================
sub main
  Dim intWidth
  Dim objArgs
  Dim strToolDir
  Dim strWorkDir
  Dim strTargetPath
  Dim isFile
  
  Set objFso = CreateObject( "Scripting.FileSystemObject" )

  strToolDir = objFso.getParentFolderName(WScript.ScriptFullName)
  strWorkDir = strToolDir & "\out"
  
  If objFso.FolderExists(strWorkDir) = False Then
    objFso.CreateFolder(strWorkDir)
  End If

  Set objArgs = WScript.Arguments
  If objArgs.Count <> 1 Then
    Call MsgBox("hbOt@ĆA1ł肢܂B" & vbCrLf & "FileCount = " & objArgs.Count )
    Wscript.Quit()
  End If

  strTargetPath = objArgs(0)
  If objFso.FileExists(strTargetPath) = True Then
    isFile=True
  Else
    isFile=False
  End If

  If Not isImgFile(strTargetPath) And isFile Then
    Call MsgBox("w̃t@ĆAł܂B")
    Wscript.Quit()
  End if

  intWidth = InputBox("͂ĂB" & vbCrLf & "(AXyNg͌ŒłB)" & vbCrLf & vbCrLf & _
                           "F1920x1080̉摜ɑ΂A960w肵ꍇ --" & vbCrLf & "  F960AcF540̒ɏk܂B"  & vbCrLf & _
                           "  t@CTCY1/3`1/4xɂȂ܂B" , "w", "800")

  If IsEmpty(intWidth) Or Not IsNumeric(intWidth) then 
    Call MsgBox("LZ܂B")
    Wscript.Quit()
  End if
  
  If isFile Then
    Call ProcessingFile(strTargetPath, strWorkDir, intWidth)
  Else
    Call ProcessingFolder(strTargetPath, strWorkDir, intWidth)
  End If
  
  Wscript.Echo "I܂B"

  Set objFso = Nothing
End Sub

main
